function [xTrue,z]=XZGen(F,B,Q,R,H,u)

%    [xTrue,z]=XZGen(F,B,Q,R,H,u)
%Eloallitja a mrshez szuksges "valdi" szimullt (skalr) jelesorozatot - xTrue,
%s az rzkelok jeleinek sorozatt - z. Az rzkel?k szmt (NS) a H megfigyelsi vektor hatrozza
%meg. A mrsi sorozat hosszt az 'u' bemeneti jel hossza hatrozza meg (N).
%Az rzkelo jelsorozat mrete ennek megfelel?en size(z)=[NS,N]. 
% Az llapotegyenlet:
%     x(k)=F*x(k-1)+B*u(k)+v;
% ahol v egy nulla vrhat rtk? Q szrs fehrzaj.
% s a megfigyelsi egyenlet:
%     z(k)=H*x(k)+w(k);
% ahol H hatrozza meg, hogy hny szenzorunk van (size(H)=[NSz,1])) ,
% w(k) pedig egy NS dimenzis nulla vrhatrtk? Gauss mrsi zaj, a koveriancia mtrixa
% diagonl (a zajok egymssal nem korrelltak, mrete: size(R)=[NS,NS].





%% bemeneti jel, megfigyelsi vektor (mretellen?rzs)
%u=ones(1,N);  VAGY u=ones(N,1) MINDEGY  
% A becslsi lpsek szma
if min(size(u))~=1, disp('a bemeneti vektor (u) helyett mtrix van megadva!'); return, end
N=max(size(u));   % a bemeneti jel hossza N, a mintk szma
if N<10, disp('a bemeneti vektor tl rvid (N<10)!');return,end 
if size(H,2)~=1, disp('a megfigyelsi vektor oszlopvektor kell legyen!'); return, end
%A szenzorok szma
NS=size(H,1);
%% az llapotegyenlet (megadott paramterek F,B,Q mretellen?rzse)

% x(k)=F*x(k-1)+B*u(k)+v;
% v variancijt  Q adja

if not(isscalar(F)) || not(isscalar(B))  || not(isscalar(Q)),
    disp('az llapotegyenlet mindhrom paramtere (F,B,Q) skalr kell legyen!');
    return,
end

%A mrsi sorozat e?lltsa. A kezdeti rtk itt mindig 0, fel kell venni 
%j bemeneti paramternek - s innen trlni a nullba lltst -, ha ms
%kell.

xTrue=zeros(1,N);
xTrue(1)=0;
for kk=2:N
    xTrue(kk)=F*xTrue(kk-1)+B*u(kk)+sqrt(Q)*randn;
end


%% megfigyelsi egyenlet

%z(k)=H*x(k)+w
% w mrsi zaj
%H=ones(3,1);
%SigmaM=1;

z=H*xTrue+R*randn(NS,N);


